﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Diagnostics;

namespace ConsoleAppLevel2Class
{
    public class OrderProcessing
    {
        public void Run()
        {
            // Create some orders
            var orders = new[]
            {
                new Order(1001, 100.00m, 10000),
                new Order(1002, 252.43m, 20000),
                new Order(1003, 92.47m, 1000)
            };
        
            // Thread Class
            // loop thru each order and process the order in parallel threads

            foreach (var order in orders)
            {
                var thread = new Thread(() => ProcessOrder(order));
                thread.Start();

            } // foreach

        } // Run

        private void ProcessOrder(Order order)
        {

            // Stopwatch Class
            Stopwatch stopwatch = Stopwatch.StartNew();

            Console.WriteLine("Stuff going on here...");

            // Timer for Processing
            // Task Manager
            Thread.Sleep(order.OrderTimer);

            // Stop Stopwatch
            stopwatch.Stop();

            // Output some order info at the end of process
            Console.WriteLine($"Processed Order ID: {order.OrderID} in {stopwatch.ElapsedMilliseconds} milliseconds.");
        } // ProcessOrder

    } // OrderProcessing
}
