﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleAppLevel2Class
{
    public class Person
    {
        // Chapter 10 variables for Lambda Expression
        public string FirstName
        {
            get; set;
        }
        public string LastName
        {
            get; set;
        }
        public string State
        {
            get; set;
        }

        // call or pass Person("Bob", "Smith")
        public Person(string firstName, string lastName, string state)
        {
            FirstName = firstName;
            LastName = lastName;
            State = state;
        }



        // Anonymous Type "type does not have to be explicitly defined
        // 1. read an object 2. query an object LINQ

        /*  Chapter 10 LINQ
        var person = new
        {
            Name = "Bob Smith",
            Age = 30
        };

        Console.WriteLine($"Contact Name: {person.Name}, Contact Age: {person.Age}");
        */

        // Tuples
        // passing args to params
        // Class<types...>(values...)

        public static Tuple<string, int> GetPersonInfo()
        {
            string name = "Bob";
            int age = 21;

            return new Tuple<string, int>(name, age);
        } // GetPersonInfo()

        // Pattern Matching using switch Chapter 8
        public static string GetContactInfo(object obj)
        {

            // switch
            // control object > obj
            // condition > switch(obj)
            // operation or expression > case return

            switch (obj)
            {
                //  obj = 7
                case int i:
                    return "The object passed is an integer";
                // obj = "7"
                case string s:
                    return "The object passed is a string";
                // obj = [21,34,7,19]
                case IEnumerable<int> n:
                    return "The object passed is a sequence of numbers";
                // obj = isNull;
                case null:
                    return "The object passed is a null";
                // obj = true
                // case bool
                default:
                    return "The object passed is either unknown or undefined.";

            } // switch

        } // GetContactInfo()


 

    } // Person Class

    // Pattern Matching using is Chapter 8 C# 8.0 and .Net 6.0 above
    /*
    object obj1 = "BOB SMITH"; // object to check in memory

    if (obj1 is string string1)
    {
        // obj can be changed/ is mutatable during the return
        Console.WriteLine(string1.ToLower());
        // use obj1 directly as a string

    }
    */



} // namespace
