﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleAppLevel2Class
{

    // Custom Attributes
    // Attribute Class > 1. AttributeUsage 2. AttributeTargets.Property
    [AttributeUsage(AttributeTargets.Property, Inherited = false, AllowMultiple = false)]
    sealed class RequiredAttribute : Attribute
    {
    public RequiredAttribute()
        {
            // constructor
        } // constructor
    } // RequiredAttribute Class


    // Main Class
    public class Product 
    {
        // Chapter 11
        // run our program from Program.cs
        // Attrs are adding metadata to your code
        // Product(Name = "value", Price = "value").Description(value)

        [Required]
        public string Name // Product(Name = "Widget1")
        { get; set; }

        [Required]
        public decimal Price  // Product(Price = 25.52)
        { get; set; }

        public string Description // Product.Description(value)
        { get; set; }
    }
}
