﻿using ConsoleAppLevel2Class;
using System.Reflection;
using System.Text.RegularExpressions;

// AttributeExample
// What we are going to call in Main to created the Class and the Class attributes
public class AttributeExample
{
    public void Run()
    {
        // Set the values of the attrs and variables
        var productValues = new 
        {
            Name = "Widget 1", // attr as string
            Price = 52.32m, // attr as decimal
            Description = "Blue Widget" // string variable
        };

        // Get the property values and create the object
        var product = new Product
        {
            Name = productValues.Name,
            Price = productValues.Price,
            Description = productValues.Description
        };

        Console.WriteLine($"Name of product: {product.Name}");
        Console.WriteLine($"Price of product: {product.Price}");
        Console.WriteLine($"Description of product: {product.Description}");


       // Type type = product.GetType();
       //  PropertyInfo[] properties = type.GetProperties(); // List[1]

        // Get the values for attrs and properties


    } // Run()

} // AttributeExample




// Main Class
public class Program
{

    public static void Main()
    {

        // Attributes Chapter 11
        var example = new AttributeExample();
        example.Run();

        // Runtime Program
        Console.WriteLine("My Application");
        Console.WriteLine("==============");

        // Chapter 12 Example Run
        var orderProcessing = new OrderProcessing();
        orderProcessing.Run();


        Console.WriteLine("Enter SSN ex. ###-##-####: ");
        string input_SSN = "555-55-5555"; // string
      

        bool SSN_isValid = ValidateSSN(input_SSN); // true or !true

        // lambda expression chapter 10
        // (param ? true : false)

        Console.WriteLine($"{input_SSN} is " + (SSN_isValid ? "valid." : "not valid."));

        // Lambda to join first name and last name to full name
        List<Person> people = new List<Person>
        {
            new Person("John", "Doe", "IA"),
            new Person("Jane", "Doe", "FL"),
            new Person("Bob", "Smith", "TX"),
            new Person("Betty", "Jones", "FL"),
            new Person("Alice", "Johnson", "AL")
        }; // List<People>

        var fullNames = people.Select(fullName => $"{fullName.FirstName} {fullName.LastName}");
        Console.WriteLine("Person Full Names: ");
        // foreach is a better choice than for becuase the data structure and output are already created for us by the Lambda... other reasons why...
        // for x in ys   "in"
        // x local var scope {}
        // ys is the data set
        foreach (var fullName in fullNames)
        {
            // x in the scope
            Console.WriteLine(fullName);
           
        } // foreach

        // LINQ Chapter 10
        var peopleinFL = from person in people where person.State == "FL" select $"{person.FirstName} {person.LastName}";

        Console.WriteLine("People in Florida:");
        foreach (var fullName in peopleinFL)
        {
            Console.WriteLine(fullName);
        }



        /*
        ResourceManager resourceManager1 = new ResourceManager();
        resourceManager1.ManipulateResourceDirectly();
        
        GarbageCollectionDemo.RunDemo(); // Dispose()
        */

        using (SafeMemoryManipulator manipulator = new SafeMemoryManipulator(1024))
        {
            manipulator.WriteToBuffer(123, 0);
        }

        GC.Collect();
        GC.WaitForPendingFinalizers();


    } // Main


    // Calculator.cs
    // Person.cs

    // Regular Expressions Chapter 8
    // testing regular expressions regex101.com
    // patterns regexlib.com
    public static bool ValidateSSN(string ssn)
    {

        string string1 = @"^\d{3}-\d{2}-\d{4}$";
        Regex pattern = new Regex(string1);

        return pattern.IsMatch(ssn); // ssn value is passed as arg when called in Main()
    
    } // ValidateSSN

} // Program Class
// EOF Program.cs